/**
 * Fuse.js v6.3.0 - Lightweight fuzzy-search (http://fusejs.io)
 *
 * Copyright (c) 2020 Kiro Risk (http://kiro.me)
 * All Rights Reserved. Apache Software License 2.0
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 */
function t(t){return Array.isArray?Array.isArray(t):"[object Array]"===Object.prototype.toString.call(t)}function e(t){return"string"==typeof t}function s(t){return"number"==typeof t}function n(t){return null!=t}function r(t){return!t.trim().length}const i=Object.prototype.hasOwnProperty;class c{constructor(t){this._keys=[],this._keyMap={};let e=0;t.forEach(t=>{let s=o(t);e+=s.weight,this._keys.push(s),this._keyMap[s.id]=s,e+=s.weight}),this._keys.forEach(t=>{t.weight/=e})}get(t){return this._keyMap[t]}keys(){return this._keys}toJSON(){return JSON.stringify(this._keys)}}function o(s){let n=null,r=null,c=null,o=1;if(e(s)||t(s))c=s,n=h(s),r=a(s);else{if(!i.call(s,"name"))throw new Error((t=>`Missing ${t} property in key`)("name"));const t=s.name;if(c=t,i.call(s,"weight")&&(o=s.weight,o<=0))throw new Error((t=>`Property 'weight' in key '${t}' must be a positive integer`)(t));n=h(t),r=a(t)}return{path:n,id:r,weight:o,src:c}}function h(e){return t(e)?e:e.split(".")}function a(e){return t(e)?e.join("."):e}var l={isCaseSensitive:!1,includeScore:!1,keys:[],shouldSort:!0,sortFn:(t,e)=>t.score===e.score?t.idx<e.idx?-1:1:t.score<e.score?-1:1,includeMatches:!1,findAllMatches:!1,minMatchCharLength:1,location:0,threshold:.6,distance:100,...{useExtendedSearch:!1,getFn:function(r,i){let c=[],o=!1;const h=(r,i,a)=>{if(i[a]){const l=r[i[a]];if(!n(l))return;if(a===i.length-1&&(e(l)||s(l)))c.push(function(t){return null==t?"":function(t){if("string"==typeof t)return t;let e=t+"";return"0"==e&&1/t==-1/0?"-0":e}(t)}(l));else if(t(l)){o=!0;for(let t=0,e=l.length;t<e;t+=1)h(l[t],i,a+1)}else i.length&&h(l,i,a+1)}else c.push(r)};return h(r,i,0),o?c:c[0]},ignoreLocation:!1,ignoreFieldNorm:!1}};const u=/[^ ]+/g;class d{constructor({getFn:t=l.getFn}={}){this.norm=function(t=3){const e=new Map;return{get(s){const n=s.match(u).length;if(e.has(n))return e.get(n);const r=parseFloat((1/Math.sqrt(n)).toFixed(t));return e.set(n,r),r},clear(){e.clear()}}}(3),this.getFn=t,this.isCreated=!1,this.setIndexRecords()}setSources(t=[]){this.docs=t}setIndexRecords(t=[]){this.records=t}setKeys(t=[]){this.keys=t,this._keysMap={},t.forEach((t,e)=>{this._keysMap[t.id]=e})}create(){!this.isCreated&&this.docs.length&&(this.isCreated=!0,e(this.docs[0])?this.docs.forEach((t,e)=>{this._addString(t,e)}):this.docs.forEach((t,e)=>{this._addObject(t,e)}),this.norm.clear())}add(t){const s=this.size();e(t)?this._addString(t,s):this._addObject(t,s)}removeAt(t){this.records.splice(t,1);for(let e=t,s=this.size();e<s;e+=1)this.records[e].i-=1}getValueForItemAtKeyId(t,e){return t[this._keysMap[e]]}size(){return this.records.length}_addString(t,e){if(!n(t)||r(t))return;let s={v:t,i:e,n:this.norm.get(t)};this.records.push(s)}_addObject(s,i){let c={i:i,$:{}};this.keys.forEach((i,o)=>{let h=this.getFn(s,i.path);if(n(h))if(t(h)){let s=[];const i=[{nestedArrIndex:-1,value:h}];for(;i.length;){const{nestedArrIndex:c,value:o}=i.pop();if(n(o))if(e(o)&&!r(o)){let t={v:o,i:c,n:this.norm.get(o)};s.push(t)}else t(o)&&o.forEach((t,e)=>{i.push({nestedArrIndex:e,value:t})})}c.$[o]=s}else if(!r(h)){let t={v:h,n:this.norm.get(h)};c.$[o]=t}}),this.records.push(c)}toJSON(){return{keys:this.keys,records:this.records}}}function g(t,e,{getFn:s=l.getFn}={}){const n=new d({getFn:s});return n.setKeys(t.map(o)),n.setSources(e),n.create(),n}function f(t,e){const s=t.matches;e.matches=[],n(s)&&s.forEach(t=>{if(!n(t.indices)||!t.indices.length)return;const{indices:s,value:r}=t;let i={indices:s,value:r};t.key&&(i.key=t.key.src),t.idx>-1&&(i.refIndex=t.idx),e.matches.push(i)})}function p(t,e){e.score=t.score}function M(t,{errors:e=0,currentLocation:s=0,expectedLocation:n=0,distance:r=l.distance,ignoreLocation:i=l.ignoreLocation}={}){const c=e/t.length;if(i)return c;const o=Math.abs(n-s);return r?c+o/r:o?1:c}function m(t,e,s,{location:n=l.location,distance:r=l.distance,threshold:i=l.threshold,findAllMatches:c=l.findAllMatches,minMatchCharLength:o=l.minMatchCharLength,includeMatches:h=l.includeMatches,ignoreLocation:a=l.ignoreLocation}={}){if(e.length>32)throw new Error(`Pattern length exceeds max of ${32}.`);const u=e.length,d=t.length,g=Math.max(0,Math.min(n,d));let f=i,p=g;const m=o>1||h,y=m?Array(d):[];let x;for(;(x=t.indexOf(e,p))>-1;){let t=M(e,{currentLocation:x,expectedLocation:g,distance:r,ignoreLocation:a});if(f=Math.min(t,f),p=x+u,m){let t=0;for(;t<u;)y[x+t]=1,t+=1}}p=-1;let k=[],L=1,_=u+d;const v=1<<u-1;for(let n=0;n<u;n+=1){let i=0,o=_;for(;i<o;){M(e,{errors:n,currentLocation:g+o,expectedLocation:g,distance:r,ignoreLocation:a})<=f?i=o:_=o,o=Math.floor((_-i)/2+i)}_=o;let h=Math.max(1,g-o+1),l=c?d:Math.min(g+o,d)+u,x=Array(l+2);x[l+1]=(1<<n)-1;for(let i=l;i>=h;i-=1){let c=i-1,o=s[t.charAt(c)];if(m&&(y[c]=+!!o),x[i]=(x[i+1]<<1|1)&o,n&&(x[i]|=(k[i+1]|k[i])<<1|1|k[i+1]),x[i]&v&&(L=M(e,{errors:n,currentLocation:c,expectedLocation:g,distance:r,ignoreLocation:a}),L<=f)){if(f=L,p=c,p<=g)break;h=Math.max(1,2*g-p)}}if(M(e,{errors:n+1,currentLocation:g,expectedLocation:g,distance:r,ignoreLocation:a})>f)break;k=x}const S={isMatch:p>=0,score:Math.max(.001,L)};if(m){const t=function(t=[],e=l.minMatchCharLength){let s=[],n=-1,r=-1,i=0;for(let c=t.length;i<c;i+=1){let c=t[i];c&&-1===n?n=i:c||-1===n||(r=i-1,r-n+1>=e&&s.push([n,r]),n=-1)}return t[i-1]&&i-n>=e&&s.push([n,i-1]),s}(y,o);t.length?h&&(S.indices=t):S.isMatch=!1}return S}function y(t){let e={};for(let s=0,n=t.length;s<n;s+=1){const r=t.charAt(s);e[r]=(e[r]||0)|1<<n-s-1}return e}class x{constructor(t,{location:e=l.location,threshold:s=l.threshold,distance:n=l.distance,includeMatches:r=l.includeMatches,findAllMatches:i=l.findAllMatches,minMatchCharLength:c=l.minMatchCharLength,isCaseSensitive:o=l.isCaseSensitive,ignoreLocation:h=l.ignoreLocation}={}){if(this.options={location:e,threshold:s,distance:n,includeMatches:r,findAllMatches:i,minMatchCharLength:c,isCaseSensitive:o,ignoreLocation:h},this.pattern=o?t:t.toLowerCase(),this.chunks=[],!this.pattern.length)return;const a=(t,e)=>{this.chunks.push({pattern:t,alphabet:y(t),startIndex:e})},u=this.pattern.length;if(u>32){let t=0;const e=u%32,s=u-e;for(;t<s;)a(this.pattern.substr(t,32),t),t+=32;if(e){const t=u-32;a(this.pattern.substr(t),t)}}else a(this.pattern,0)}searchIn(t){const{isCaseSensitive:e,includeMatches:s}=this.options;if(e||(t=t.toLowerCase()),this.pattern===t){let e={isMatch:!0,score:0};return s&&(e.indices=[[0,t.length-1]]),e}const{location:n,distance:r,threshold:i,findAllMatches:c,minMatchCharLength:o,ignoreLocation:h}=this.options;let a=[],l=0,u=!1;this.chunks.forEach(({pattern:e,alphabet:d,startIndex:g})=>{const{isMatch:f,score:p,indices:M}=m(t,e,d,{location:n+g,distance:r,threshold:i,findAllMatches:c,minMatchCharLength:o,includeMatches:s,ignoreLocation:h});f&&(u=!0),l+=p,f&&M&&(a=[...a,...M])});let d={isMatch:u,score:u?l/this.chunks.length:1};return u&&s&&(d.indices=a),d}}class k{constructor(t){this.pattern=t}static isMultiMatch(t){return L(t,this.multiRegex)}static isSingleMatch(t){return L(t,this.singleRegex)}search(){}}function L(t,e){const s=t.match(e);return s?s[1]:null}class _ extends k{constructor(t){super(t)}static get type(){return"exact"}static get multiRegex(){return/^'"(.*)"$/}static get singleRegex(){return/^'(.*)$/}search(t){let e,s=0;const n=[],r=this.pattern.length;for(;(e=t.indexOf(this.pattern,s))>-1;)s=e+r,n.push([e,s-1]);const i=!!n.length;return{isMatch:i,score:i?1:0,indices:n}}}class v extends k{constructor(t,{location:e=l.location,threshold:s=l.threshold,distance:n=l.distance,includeMatches:r=l.includeMatches,findAllMatches:i=l.findAllMatches,minMatchCharLength:c=l.minMatchCharLength,isCaseSensitive:o=l.isCaseSensitive}={}){super(t),this._bitapSearch=new x(t,{location:e,threshold:s,distance:n,includeMatches:r,findAllMatches:i,minMatchCharLength:c,isCaseSensitive:o})}static get type(){return"fuzzy"}static get multiRegex(){return/^"(.*)"$/}static get singleRegex(){return/^(.*)$/}search(t){return this._bitapSearch.searchIn(t)}}const S=[_,class extends k{constructor(t){super(t)}static get type(){return"prefix-exact"}static get multiRegex(){return/^\^"(.*)"$/}static get singleRegex(){return/^\^(.*)$/}search(t){const e=t.startsWith(this.pattern);return{isMatch:e,score:e?0:1,indices:[0,this.pattern.length-1]}}},class extends k{constructor(t){super(t)}static get type(){return"inverse-prefix-exact"}static get multiRegex(){return/^!\^"(.*)"$/}static get singleRegex(){return/^!\^(.*)$/}search(t){const e=!t.startsWith(this.pattern);return{isMatch:e,score:e?0:1,indices:[0,t.length-1]}}},class extends k{constructor(t){super(t)}static get type(){return"inverse-suffix-exact"}static get multiRegex(){return/^!"(.*)"\$$/}static get singleRegex(){return/^!(.*)\$$/}search(t){const e=!t.endsWith(this.pattern);return{isMatch:e,score:e?0:1,indices:[0,t.length-1]}}},class extends k{constructor(t){super(t)}static get type(){return"suffix-exact"}static get multiRegex(){return/^"(.*)"\$$/}static get singleRegex(){return/^(.*)\$$/}search(t){const e=t.endsWith(this.pattern);return{isMatch:e,score:e?0:1,indices:[t.length-this.pattern.length,t.length-1]}}},class extends k{constructor(t){super(t)}static get type(){return"inverse-exact"}static get multiRegex(){return/^!"(.*)"$/}static get singleRegex(){return/^!(.*)$/}search(t){const e=-1===t.indexOf(this.pattern);return{isMatch:e,score:e?0:1,indices:[0,t.length-1]}}},v],C=S.length,I=/ +(?=([^\"]*\"[^\"]*\")*[^\"]*$)/;const w=new Set([v.type,_.type]);class A{constructor(t,{isCaseSensitive:e=l.isCaseSensitive,includeMatches:s=l.includeMatches,minMatchCharLength:n=l.minMatchCharLength,findAllMatches:r=l.findAllMatches,location:i=l.location,threshold:c=l.threshold,distance:o=l.distance}={}){this.query=null,this.options={isCaseSensitive:e,includeMatches:s,minMatchCharLength:n,findAllMatches:r,location:i,threshold:c,distance:o},this.pattern=e?t:t.toLowerCase(),this.query=function(t,e={}){return t.split("|").map(t=>{let s=t.trim().split(I).filter(t=>t&&!!t.trim()),n=[];for(let t=0,r=s.length;t<r;t+=1){const r=s[t];let i=!1,c=-1;for(;!i&&++c<C;){const t=S[c];let s=t.isMultiMatch(r);s&&(n.push(new t(s,e)),i=!0)}if(!i)for(c=-1;++c<C;){const t=S[c];let s=t.isSingleMatch(r);if(s){n.push(new t(s,e));break}}}return n})}(this.pattern,this.options)}static condition(t,e){return e.useExtendedSearch}searchIn(t){const e=this.query;if(!e)return{isMatch:!1,score:1};const{includeMatches:s,isCaseSensitive:n}=this.options;t=n?t:t.toLowerCase();let r=0,i=[],c=0;for(let n=0,o=e.length;n<o;n+=1){const o=e[n];i.length=0,r=0;for(let e=0,n=o.length;e<n;e+=1){const n=o[e],{isMatch:h,indices:a,score:l}=n.search(t);if(!h){c=0,r=0,i.length=0;break}if(r+=1,c+=l,s){const t=n.constructor.type;w.has(t)?i=[...i,...a]:i.push(a)}}if(r){let t={isMatch:!0,score:c/r};return s&&(t.indices=i),t}}return{isMatch:!1,score:1}}}const $=[];function E(t,e){for(let s=0,n=$.length;s<n;s+=1){let n=$[s];if(n.condition(t,e))return new n(t,e)}return new x(t,e)}const b="$and",F="$or",R="$path",O="$val",j=t=>!(!t[b]&&!t[F]),N=t=>({[b]:Object.keys(t).map(e=>({[e]:t[e]}))});function z(s,n,{auto:r=!0}={}){const i=s=>{let c=Object.keys(s);const o=(t=>!!t[R])(s);if(!o&&c.length>1&&!j(s))return i(N(s));if((e=>!t(e)&&"object"==typeof e&&!j(e))(s)){const t=o?s[R]:c[0],i=o?s[O]:s[t];if(!e(i))throw new Error((t=>"Invalid value for key "+t)(t));const h={keyId:a(t),pattern:i};return r&&(h.searcher=E(i,n)),h}let h={children:[],operator:c[0]};return c.forEach(e=>{const n=s[e];t(n)&&n.forEach(t=>{h.children.push(i(t))})}),h};return j(s)||(s=N(s)),i(s)}class K{constructor(t,e={},s){this.options={...l,...e},this.options.useExtendedSearch,this._keyStore=new c(this.options.keys),this.setCollection(t,s)}setCollection(t,e){if(this._docs=t,e&&!(e instanceof d))throw new Error("Incorrect 'index' type");this._myIndex=e||g(this.options.keys,this._docs,{getFn:this.options.getFn})}add(t){n(t)&&(this._docs.push(t),this._myIndex.add(t))}remove(t=(()=>!1)){const e=[];for(let s=0,n=this._docs.length;s<n;s+=1){const n=this._docs[s];t(n,s)&&(this.removeAt(s),s-=1,e.push(n))}return e}removeAt(t){this._docs.splice(t,1),this._myIndex.removeAt(t)}getIndex(){return this._myIndex}search(t,{limit:n=-1}={}){const{includeMatches:r,includeScore:i,shouldSort:c,sortFn:o,ignoreFieldNorm:h}=this.options;let a=e(t)?e(this._docs[0])?this._searchStringList(t):this._searchObjectList(t):this._searchLogical(t);return function(t,e,{ignoreFieldNorm:s=l.ignoreFieldNorm}){t.forEach(t=>{let e=1;t.matches.forEach(({key:t,norm:n,score:r})=>{const i=t?t.weight:null;e*=Math.pow(0===r&&i?Number.EPSILON:r,(i||1)*(s?1:n))}),t.score=e})}(a,this._keyStore,{ignoreFieldNorm:h}),c&&a.sort(o),s(n)&&n>-1&&(a=a.slice(0,n)),function(t,e,{includeMatches:s=l.includeMatches,includeScore:n=l.includeScore}={}){const r=[];s&&r.push(f);n&&r.push(p);return t.map(t=>{const{idx:s}=t,n={item:e[s],refIndex:s};return r.length&&r.forEach(e=>{e(t,n)}),n})}(a,this._docs,{includeMatches:r,includeScore:i})}_searchStringList(t){const e=E(t,this.options),{records:s}=this._myIndex,r=[];return s.forEach(({v:t,i:s,n:i})=>{if(!n(t))return;const{isMatch:c,score:o,indices:h}=e.searchIn(t);c&&r.push({item:t,idx:s,matches:[{score:o,value:t,norm:i,indices:h}]})}),r}_searchLogical(t){const e=z(t,this.options),s=this._myIndex.records,r={},i=[],c=(t,e,s)=>{if(t.children){const n=t.operator;let r=[];for(let i=0;i<t.children.length;i+=1){let o=t.children[i],h=c(o,e,s);if(h&&h.length){if(r.push({idx:s,item:e,matches:h}),n===F)break}else if(n===b){r.length=0;break}}return r}{const{keyId:s,searcher:n}=t,r=this._myIndex.getValueForItemAtKeyId(e,s);return this._findMatches({key:this._keyStore.get(s),value:r,searcher:n})}};return s.forEach(({$:t,i:s})=>{if(n(t)){let n=c(e,t,s);n.length&&(r[s]||(r[s]={idx:s,item:t,matches:[]},i.push(r[s])),n.forEach(({matches:t})=>{r[s].matches.push(...t)}))}}),i}_searchObjectList(t){const e=E(t,this.options),{keys:s,records:r}=this._myIndex,i=[];return r.forEach(({$:t,i:r})=>{if(!n(t))return;let c=[];s.forEach((s,n)=>{c.push(...this._findMatches({key:s,value:t[n],searcher:e}))}),c.length&&i.push({idx:r,item:t,matches:c})}),i}_findMatches({key:e,value:s,searcher:r}){if(!n(s))return[];let i=[];if(t(s))s.forEach(({v:t,i:s,n:c})=>{if(!n(t))return;const{isMatch:o,score:h,indices:a}=r.searchIn(t);o&&i.push({score:h,key:e,value:t,idx:s,norm:c,indices:a})});else{const{v:t,n:n}=s,{isMatch:c,score:o,indices:h}=r.searchIn(t);c&&i.push({score:o,key:e,value:t,norm:n,indices:h})}return i}}K.version="6.3.0",K.createIndex=g,K.parseIndex=function(t,{getFn:e=l.getFn}={}){const{keys:s,records:n}=t,r=new d({getFn:e});return r.setKeys(s),r.setIndexRecords(n),r},K.config=l,function(...t){$.push(...t)}(A);export default K;